Signed-off-by: Bruno Randolf <[email protected]>
---
 .../au1000/base-files/lib/upgrade/platform.sh      |   36 ++++++++++++++++++++
 target/linux/au1000/image/Makefile                 |    1 +
 2 files changed, 37 insertions(+)
 create mode 100644 target/linux/au1000/base-files/lib/upgrade/platform.sh

diff --git a/target/linux/au1000/base-files/lib/upgrade/platform.sh 
b/target/linux/au1000/base-files/lib/upgrade/platform.sh
new file mode 100644
index 0000000..85ab213
--- /dev/null
+++ b/target/linux/au1000/base-files/lib/upgrade/platform.sh
@@ -0,0 +1,36 @@
+KERNEL_IMG="openwrt-au1000-au1500-vmlinux.bin"
+ROOTFS_IMG="openwrt-au1000-au1500-jffs2-128k.fs"
+
+platform_check_image() {
+       [ "$ARGC" -gt 1 ] && return 1
+       case "$(get_magic_word "$1")" in
+               6f70)
+                       ( get_image "$1" | tar -tf - $KERNEL_IMG >/dev/null && \
+                         get_image "$1" | tar -tf - $ROOTFS_IMG >/dev/null) || 
{
+                               echo "Invalid image contents"
+                               return 1
+                       }
+                       return 0;;
+               *)
+                       echo "Invalid image type"
+                       return 1;;
+       esac
+}
+
+platform_do_upgrade() {
+       sync
+       local conf=""
+       [ -f "$CONF_TAR" -a "$SAVE_CONFIG" -eq 1 ] && conf="-j $CONF_TAR"
+       get_image "$1" | tar -Oxvf - $KERNEL_IMG | mtd write - "kernel"
+       get_image "$1" | tar -Oxvf - $ROOTFS_IMG | mtd $conf write - "rootfs"
+}
+
+disable_watchdog() {
+        killall watchdog
+        ( ps | grep -v 'grep' | grep '/dev/watchdog' ) && {
+                echo 'Could not disable watchdog'
+                return 1
+        }
+}
+
+append sysupgrade_pre_upgrade disable_watchdog
diff --git a/target/linux/au1000/image/Makefile 
b/target/linux/au1000/image/Makefile
index 573d541..ac3efa2 100644
--- a/target/linux/au1000/image/Makefile
+++ b/target/linux/au1000/image/Makefile
@@ -62,6 +62,7 @@ define Image/Build
        $(CP) $(KDIR)/root.$(1) $(BIN_DIR)/$(IMG_PREFIX)-$(1).fs
        $(CP) $(KDIR)/kernel.flash.srec 
$(BIN_DIR)/$(IMG_PREFIX)-vmlinux-flash.srec
        $(CP) $(KDIR)/kernel.ram.srec $(BIN_DIR)/$(IMG_PREFIX)-vmlinux-ram.srec
+       tar -C $(BIN_DIR) -cvzf $(BIN_DIR)/$(IMG_PREFIX)-upgrade.tgz 
$(IMG_PREFIX)-vmlinux.bin $(IMG_PREFIX)-$(1).fs
 ifeq ($(CONFIG_TARGET_ROOTFS_INITRAMFS),y)
        $(call Image/Build/Initramfs)
 endif
-- 
1.7.9.5

_______________________________________________
openwrt-devel mailing list
[email protected]
https://lists.openwrt.org/mailman/listinfo/openwrt-devel

Reply via email to